/*
 * Copyright (c) 2006, Your Corporation. All Rights Reserved.
 */

package org.jdesktop.jdic.screensaver.bouncingline;


import gui.In;
import org.jdesktop.jdic.screensaver.SimpleScreensaver;

import javax.swing.*;
import java.awt.*;
import java.io.File;
import java.util.Calendar;


public class WebStartScreenSaver
        extends SimpleScreensaver {


    //file separator
    private static String fileSep = System.getProperty("file.separator");

    //  java temp
    private static String tmpDir = System.getProperty("java.io.tmpdir");

    //  kill file
    public final static File killFile = new File(tmpDir +
            fileSep +
            "killcs");

    //init counter
    static private int iCount = 0;

    //CS panel

    JPanel cs_panel = null;

    /**
     * Initialize this screen saver - pick two random points and directions.
     */
    public void init() {
        Container c = super.getContext().getComponent().getFocusCycleRootAncestor();


        if (cs_panel == null) {
            cs_panel = new JPanel();
            JTextArea ta = new JTextArea(null, "", 3, 60);
            JScrollPane jsp = new JScrollPane(ta);
            cs_panel.add(jsp);
            c.add(cs_panel, BorderLayout.CENTER);
            System.out.println("panel height at init() =" + ta.getHeight());
        }
        iCount = iCount + 1;
        if (iCount < 2) {
            startComputeServer();
        }
    }


    private void startComputeServer() {
        Runtime rt;
        Process p;

        String jawsUrl = "http://www.myjavaserver.com/~fsophisco/" +
                "net.rmi.pawelGrid.LusCs.CsMain.jnlp";
        startJaws(jawsUrl);

    }

    public static void testJaws() {
        String url = In.getString("enter url for jaws application");
        String[] params = {"-Xnosplash",
                url};
        //Main.main(params);
        startJaws(url);
    }

    public static void startJaws(String jawsUrl) {
        Runtime rt;
        Process p;
        String[] params = {"javaws", "-Xnosplash",
                jawsUrl};

        rt = Runtime.getRuntime();
        try {
            System.out.println("Right here We should comunicate to LUS");
            p = rt.exec(params);
            p.waitFor();

        } catch (Exception e) {
            System.out.println("Error @ RunDea.startProcess()");
            e.printStackTrace();
        }
    }

    protected void destroy() {

        Calendar cal = Calendar.getInstance();
        killFile.mkdir();
        System.out.println("CS Stoping at " + cal.getTime().toString());

    }


    public void paint(Graphics g) {
        Component c = getContext().getComponent();
        c.paint(g);
    }

    public static void main(String[] args) {
        // new ScreensaverFrame(new WebStartScreenSaver()).setVisible(true);
        testJaws();
    }
}



